/*
 * Kinematics.cpp
 *
 *  Created on: 17 NOV 2016
 *      Author: Roman Ryutin
 */

#include <cmath>
#include <complex>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <map>
#include <string>
#include <utility>
#include <vector>
#include <stdio.h>
#include <cassert>

#include "../inc/I.h"
#include "../inc/PI.h"
#include "../inc/Particle.h"
#include "../inc/Constants.h"
#include "../inc/Kinematics.h"

// functions of class KinCM ===========================================
// here and everywhere t variables mean abs(t)!!!
//
/*
ExDiff::KinCM::~KinCM(){
	
};
*/
// print information
void ExDiff::KinCM::Print(){
	std::cout<< " ============================================= " <<std::endl;
	printf("p_initial[ 1 ] = { %.6f , %.6f , %.6f , %.6f }\n", hadron1._p()[0], hadron1._p()[1], hadron1._p()[2], hadron1._p()[3]);
	printf("p_initial[ 2 ] = { %.6f , %.6f , %.6f , %.6f }\n", hadron2._p()[0], hadron2._p()[1], hadron2._p()[2], hadron2._p()[3]);	
//	std::cout<< "p_initial[1] = {" << hadron1._p()[0] << " , " << hadron1._p()[1] << " , " << hadron1._p()[2] << " , " << hadron1._p()[3] << " } " <<std::endl;
//	std::cout<< "p_initial[2] = {" << hadron2._p()[0] << " , " << hadron2._p()[1] << " , " << hadron2._p()[2] << " , " << hadron2._p()[3] << " } " <<std::endl;	  
	if(particles.size() == 2){
 	 std::cout<< "Kinematical variables for 2 to 2 process" <<std::endl;
     printf("t = %.8f, theta = %.9f, y = %.9f \n", t, theta, y);	 
     printf("phi = %.6f, DeltaT = %.6f, Delta3D = %.6f \n", phi, DeltaT, Delta3D);	 
//     std::cout<< "t = " << t <<std::endl;
//     std::cout<< "theta = " << theta <<std::endl;
//     std::cout<< "y = " << y <<std::endl;	
//     std::cout<< "phi = " << phi <<std::endl; 
//     std::cout<< "DeltaT = " << DeltaT <<std::endl;
//     std::cout<< "Delta3D = " << Delta3D <<std::endl;	
	 printf("Delta = { %.6f , %.6f , %.6f , %.6f }\n", Delta[0], Delta[1], Delta[2], Delta[3]);
//     std::cout<< "Delta = {" << Delta[0] << " , " << Delta[1] << " , " << Delta[2] << " , " << Delta[3] << " } " <<std::endl;
     for(int i = 0; i < 2; i++){
	  printf("p_final[ %1i ] = { %.6f , %.6f , %.6f , %.6f }\n", i, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3]); 
//	  std::cout<< "p_final[ " << i << " ] = {" << particles[i]._p()[0] << " , " << particles[i]._p()[1] << " , " << particles[i]._p()[2] << " , " << particles[i]._p()[3] << " } " <<std::endl;
	 } 	
 
    }
	if(particles.size() == 3 || particles.size() == 4){
	 if(particles.size() == 3){
	  std::cout<< "Kinematical variables for 2 to 3 process" <<std::endl;	
     } 	 
	 if(particles.size() == 4){
	  std::cout<< "Kinematical variables for 2 to 4 processe" <<std::endl;	
     } 	 
     printf("t1 = %.6f, t2 = %.6f, DeltaT_1 = %.6f, DeltaT_2 = %.6f \n", t_1, t_2, DeltaT_1, DeltaT_2);	
     printf("phi_12 = %.6f, phi_1 = %.6f, xi_1 = %.6f, xi_2 = %.6f \n", phi_12, phi_1, xi_1, xi_2);
     printf("y_c = %.6f, M_c = %.6f, M_T = %.6f \n", y_c, M_c, M_T);			 
//     std::cout<< "t1 = " << t_1 <<std::endl;
//     std::cout<< "t2 = " << t_2 <<std::endl;
//     std::cout<< "DeltaT_1 = " << DeltaT_1 <<std::endl;
//     std::cout<< "DeltaT_2 = " << DeltaT_2 <<std::endl;
//     std::cout<< "phi_12 = " << phi_12 <<std::endl;
//     std::cout<< "phi_1 = " << phi_1 <<std::endl;
//     std::cout<< "xi_1 = " << xi_1 <<std::endl;
//     std::cout<< "xi_2 = " << xi_2 <<std::endl;
//     std::cout<< "y_c = " << y_c <<std::endl;
//     std::cout<< "M_c = " << M_c <<std::endl;	
//     std::cout<< "M_T = " << M_T <<std::endl;	
	 printf("Delta_1 = { %.6f , %.6f , %.6f , %.6f }\n", Delta_1[0], Delta_1[1], Delta_1[2], Delta_1[3]);
	 printf("Delta_2 = { %.6f , %.6f , %.6f , %.6f }\n", Delta_2[0], Delta_2[1], Delta_2[2], Delta_2[3]);	 
//     std::cout<< "Delta_1 = {" << Delta_1[0] << " , " << Delta_1[1] << " , " << Delta_1[2] << " , " << Delta_1[3] << " } " <<std::endl;
//     std::cout<< "Delta_2 = {" << Delta_2[0] << " , " << Delta_2[1] << " , " << Delta_2[2] << " , " << Delta_2[3] << " } " <<std::endl;	 
     for(int i = 0; i < particles.size(); i++){
	  printf("p_final[ %1i ] = { %.6f , %.6f , %.6f , %.6f }\n", i, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3]);		 
//	  std::cout<< "p_final[ " << i << " ] = {" << particles[i]._p()[0] << " , " << particles[i]._p()[1] << " , " << particles[i]._p()[2] << " , " << particles[i]._p()[3] << " } " <<std::endl;
	 } 		 	 
    }
	if(particles.size() == 4){
//	 std::cout<< "Additional kinematical variables for 2 to 4 process" <<std::endl;		
     printf("Eta_j = %.6f, Theta_j = %.6f, Phi_j = %.6f \n", Eta_j, Theta_j, Phi_j);	
	 printf("s_hat = %.6f, t_hat = %.6f \n", s_hat, t_hat);
	 printf("y_a = %.6f, y_b = %.6f, k_ab_x = %.6f, k_ab_y = %.6f, phi_ab = %.6f \n", y_a, y_b, k_ab_x, k_ab_y, phi_ab);
//     std::cout<< "Eta_j = " << Eta_j <<std::endl;	
//     std::cout<< "Theta_j = " << Theta_j <<std::endl;
//     std::cout<< "Phi_j = " << Phi_j <<std::endl;     	 
    }		
	std::cout<< " ============================================= " <<std::endl;
	return;
};
// initialization of all variables and vectors 
//////////////////////////////
void ExDiff::KinCM::VtoP2(std::size_t& _ID, std::vector<double>& _masses, std::vector<int>& _IDs){
    double beta = sqrt(1.0-4.0*_masses[0]*_masses[0]/sqs/sqs);
    phi = variables[1];
	Delta[0] = 0.0;	
// classical variables = {|t|,phi}		
	if(_ID == 0){
	   t = variables[0];	
       theta = acos(1.0 - 2.0*t/sqs/sqs/beta/beta);
	   DeltaT = sqrt(t*(1.0-t/sqs/sqs/beta/beta));		   
	}		
// variables = {theta of the final hadron, phi}	
	if(_ID == 1){
	   theta = variables[0];	
	   t = 0.5*sqs*sqs*beta*beta*(1.0-cos(theta));
       DeltaT = sqrt(t*(1.0-t/sqs/sqs/beta/beta));		   
	}
// variables = {rapidity of the final hadron, phi}	
	if(_ID == 2){
	   y = variables[0]; 	
	   t = 0.5*sqs*sqs*beta*(beta-tanh(y));
       theta = acos(1.0 - 2.0*t/sqs/sqs/beta/beta); 
       DeltaT = sqrt(t*(1.0-t/sqs/sqs/beta/beta));		   
	}	
// variables = {DeltaT, phi}	
	if(_ID == 3){
	   DeltaT = variables[0];	
	   t = 0.5*sqs*sqs*beta*beta*(1.0-sqrt(1.0-4.0*DeltaT*DeltaT/sqs/sqs/beta/beta));		   
	}	
    Delta[3] = t/sqs/beta;
	Delta3D = sqrt(t);
	Delta[1] = DeltaT * cos(phi);
	Delta[2] = DeltaT * sin(phi);

    std::vector<double> p1 = hadron1.Lminus(hadron1._p(),Delta);
	p1[0] = sqrt(_masses[0]*_masses[0]+p1[1]*p1[1]+p1[2]*p1[2]+p1[3]*p1[3]);
    std::vector<double> p2 = hadron2.Lplus(hadron2._p(),Delta);
	p2[0] = sqrt(_masses[1]*_masses[1]+p2[1]*p2[1]+p2[2]*p2[2]+p2[3]*p2[3]);	
	
	ExDiff::Particle fin0(p1,_masses[0],_IDs[0],hadron1._DSpin(),hadron1._Colour(),hadron1._Anticolour());
	ExDiff::Particle fin1(p2,_masses[1],_IDs[1],hadron2._DSpin(),hadron2._Colour(),hadron2._Anticolour());	
	
    particles[0] = fin0;
    particles[1] = fin1;	    	
	
	t = -hadron1.Lmult(Delta,Delta);
	y = 0.5 * log((particles[0]._E()+particles[0]._pz())/(particles[0]._E()-particles[0]._pz()));	
	theta = acos(particles[0]._pz()/particles[0]._p3D());
	
	PtoV2();
	return;

};
//////////////////////////////
void ExDiff::KinCM::DeltasInit(){
	
// solve equations (p1-Delta1)^2=m^2, (p2-Delta2)^2=m^2,
// Delta_1={xi_1*sqs/2 + A, DeltaT_1*[cos fi1, sin fi1], xi_1*sqs/2+B}
// Delta_2={xi_2*sqs/2 - A, DeltaT_1*[cos fi2, sin fi2], -xi_2*sqs/2-B}
// pc=Delta_1+Delta_2={M_T cosh(y_c), pcTx, pcTy, M_T sinh(y_c)}
// xi_1 = M_T*exp(y_c)/sqs; xi_2 = M_T*exp(-y_c)/sqs;
// 2 equations:
// (1) 0 = (xi_1*sqs/2+A)^2-(xi_1*sqs/2+B)^2-DeltaT_1^2-sqs*[(xi_1*sqs/2+A)-beta*(xi_1*sqs/2+B)]
// (2) 0 = (xi_2*sqs/2-A)^2-(-xi_2*sqs/2-B)^2-DeltaT_2^2-sqs*[(xi_2*sqs/2-A)-beta*(xi_2*sqs/2+B)]
// (1)-(2) gives A = X*B+Y*Y
// (1)+(2) gives quadratic equation 2*(1-X^2)*B^2-U*B+V=0
	double m = hadron1._m();
	double beta = sqrt(1.0-4.0*m*m/sqs/sqs);
	double X = (xi_2-xi_1)/(2-xi_2-xi_1);
	double Y = (DeltaT_2*DeltaT_2-DeltaT_1*DeltaT_1)/(2.0-xi_1-xi_2)/sqs + 0.5*X*sqs*(1.0-beta);
	double U = 4.0*X*Y+sqs*(2.0*beta-xi_1-xi_2+X*(xi_1-xi_2));
	double V = DeltaT_2*DeltaT_2+DeltaT_1*DeltaT_1+0.5*(xi_1+xi_2)*sqs*sqs*(1.0-beta);
	V = V + (xi_2-xi_1)*sqs*Y-2.0*Y*Y;
	double B = (U-sqrt(U*U-8.0*(1.0-X*X)*V))/4.0/(1.0-X*X);
	double A = X*B+Y;

	if(U*U-8.0*(1.0-X*X)*V < 0){
		flag = 2;
	}	
	
	Delta_1[0] = 0.5*xi_1*sqs+A;
	Delta_2[0] = 0.5*xi_2*sqs-A;
	
	Delta_1[3] = 0.5*xi_1*sqs+B;
	Delta_2[3] = -0.5*xi_2*sqs-B;
	
	return;
	
};	


////////////////////////////
void ExDiff::KinCM::VtoP3(std::size_t& _ID, std::vector<double>& _masses, std::vector<int>& _IDs){
     
	 while(particles.size() < 3){
   	   particles.push_back(particles[1]);
	 } 

	double m = _masses[0];
    double beta = sqrt(1.0-4.0*m*m/sqs/sqs);
	phi_12 = variables[2]; 
	phi_1 = variables[4];
	M_c = _masses[1];
// variables = {DeltaT_1,DeltaT_2,phi_12,log(xi_1),phi_1}
	if(_ID == 0){
	  DeltaT_1 = variables[0];
      DeltaT_2 = variables[1];	  
	  xi_1 = exp(variables[3]);
// then correct	  
	  M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));
      xi_2 = M_T*M_T/sqs/sqs/xi_1;	  
	  y_c = 0.5*log(xi_1/xi_2);
	}
// variables = {DeltaT_1,DeltaT_2,phi_12,y_c,phi_1}	 
	if(_ID == 1){
	  DeltaT_1 = variables[0];
      DeltaT_2 = variables[1];	  
	  y_c = variables[3];
	  M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));
      xi_1 = M_T*exp(y_c)/sqs;	  
      xi_2 = M_T*exp(-y_c)/sqs;	  		
	}
// variables = {t_1,t_2,phi_12,y_c,phi_1}	
	if(_ID == 2){
	  t_1 =	variables[0];
	  t_2 = variables[1];
	  y_c = variables[3];
	  M_T = sqrt(M_c*M_c + t_1 + t_2 + 2.0*sqrt(t_1*t_2)*cos(phi_12));
      xi_1 = M_T*exp(y_c)/sqs;
      xi_2 = M_T*exp(-y_c)/sqs;
      double aux1 = (t_1+2.0*m*m*xi_1)/sqs;
      double aux2 = (t_2+2.0*m*m*xi_2)/sqs; 	  
      DeltaT_1 = sqrt(t_1*(1-xi_1)-xi_1*xi_1*m*m+aux1*aux1);
	  DeltaT_2 = sqrt(t_2*(1-xi_2)-xi_2*xi_2*m*m+aux2*aux2);	  
	}	

// Values of Delta_1 and Delta_2 to satisfy mass-shell conditions
	DeltasInit();
	
	Delta3D_1 = sqrt(DeltaT_1*DeltaT_1+Delta_1[3]*Delta_1[3]);
	Delta3D_2 = sqrt(DeltaT_2*DeltaT_2+Delta_2[3]*Delta_2[3]);
	
	Delta_1[1] = DeltaT_1 * cos(phi_1);
	Delta_1[2] = DeltaT_1 * sin(phi_1);	
	Delta_2[1] = DeltaT_2 * cos(phi_12+phi_1);
	Delta_2[2] = DeltaT_2 * sin(phi_12+phi_1);
	
	std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);

    t_1 = -hadron1.Lmult(Delta_1,Delta_1);
	t_2 = -hadron1.Lmult(Delta_2,Delta_2);

// corrected momenta
// final hadrons an central particle	
    std::vector<double> p1_cor = hadron1.Lminus(hadron1._p(),Delta_1); 
    std::vector<double> p2_cor = hadron1.Lminus(hadron2._p(),Delta_2); 
    std::vector<double> pc_cor = {sqs-p1_cor[0]-p2_cor[0],-p1_cor[1]-p2_cor[1],-p1_cor[2]-p2_cor[2],-p1_cor[3]-p2_cor[3]};
 		
// all particles with corrected momenta
	ExDiff::Particle fin0(p1_cor,_masses[0],_IDs[0],hadron1._DSpin(),hadron1._Colour(),hadron1._Anticolour());
	ExDiff::Particle fin2(p2_cor,_masses[2],_IDs[2],hadron2._DSpin(),hadron2._Colour(),hadron2._Anticolour());
// scalar by default, spin can be changed manually
	ExDiff::Particle fin1(pc_cor,_masses[1],_IDs[1],1,0,0); 
 
	particles[0] = fin0;
	particles[1] = fin1;
	particles[2] = fin2;

// call P to V to correct variables
    PtoV3();
	return;
	
};
//////////////////////////////
void ExDiff::KinCM::VtoP4(std::size_t& _ID, std::vector<double>& _masses, std::vector<int>& _IDs){

	 while(particles.size() < 4){
   	   particles.push_back(particles[1]);
	 } 

	double m = _masses[0];
    double beta = sqrt(1.0-4.0*m*m/sqs/sqs);
    double mpi = _masses[1];
	
	double yclim;
	double etajlim;
	
    std::vector<double> p1_cor = {0.0,0.0,0.0,0.0}; 
    std::vector<double> p2_cor = {0.0,0.0,0.0,0.0}; 
    std::vector<double> pc_cor = {0.0,0.0,0.0,0.0};	
    std::vector<double> k_1 = {0.0,0.0,0.0,0.0};	
    std::vector<double> k_2 = {0.0,0.0,0.0,0.0};		
//!!!
//    if(flag != 0){
//		printf("1 flag = %1i\n", flag);
//	}
//!!!	
	
//    printf("V to P: Eta_j = %.6f, Theta_j = %.6f, Phi_j = %.6f\n", Eta_j, Theta_j, Phi_j);
// variables = {DeltaT_1,DeltaT_2,phi_12,phi_1,M_c,y_c; Eta_j, Phi_j}	
	if(_ID == 1){
	 DeltaT_1 = variables[0];
	 DeltaT_2 = variables[1];
	 phi_1 = variables[3];	
	 phi_12 = variables[2]; 
     Eta_j = variables[6];
	 Phi_j = variables[7];		
	 M_c = variables[4];
     y_c = variables[5];
	 M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));
     xi_1 = M_T*exp(y_c)/sqs;
     xi_2 = M_T*exp(-y_c)/sqs;	 
	}
// variables = {DeltaT_1,DeltaT_2,phi_12,phi_1,xi_1,xi_2; Eta_j, Phi_j}		
	if(_ID == 2){
	 DeltaT_1 = variables[0];
	 DeltaT_2 = variables[1];
	 phi_1 = variables[3];	
	 phi_12 = variables[2]; 
     Eta_j = variables[6];
	 Phi_j = variables[7];		
	 xi_1 = variables[4];
     xi_2 = variables[5];
     y_c = 0.5*log(xi_1/xi_2);
	 M_T = sqrt(xi_1*xi_2*sqs*sqs);
	 M_c = sqrt(M_T*M_T - DeltaT_1*DeltaT_1 - DeltaT_2*DeltaT_2 - 2.0*DeltaT_1*DeltaT_2*cos(phi_12));     	 
	}
// variables = {Dro,Dphiro,phi_12,M_c,y_c; Eta_j, Phi_j; phi_1}	
	if(_ID == 3){
	 DeltaT_1 = variables[0]*cos(variables[1]);
	 DeltaT_2 = variables[0]*sin(variables[1]);
	 phi_1 = variables[7];	
	 phi_12 = variables[2]; 
     Eta_j = variables[5];
	 Phi_j = variables[6];		
	 M_c = variables[3];
     y_c = variables[4];
	 M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));
     xi_1 = M_T*exp(y_c)/sqs;
     xi_2 = M_T*exp(-y_c)/sqs;	 
	}
// variables = {D1,D2,phi_12,M_c,V_y_c; V_Eta_j, Phi_j; phi_1}	
	if(_ID == 0){	
	 DeltaT_1 = variables[0];
	 DeltaT_2 = variables[1];
	 phi_1 = variables[7];	
	 phi_12 = variables[2]; 
	 Phi_j = variables[6];		
	 M_c = variables[3];
	 M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));	 
     etajlim = acosh(0.5*M_c/mpi);
	 yclim = log(0.1*sqs/M_T);
	 Eta_j = variables[5]*etajlim;
     y_c = variables[4]*yclim;
     xi_1 = M_T*exp(y_c)/sqs;
     xi_2 = M_T*exp(-y_c)/sqs;	 
	}	
// variables = {D1,D2,phi_12; y_a, y_b, k_ab_T, phi_ab; phi_1}	
	if(_ID == 4){	
	 DeltaT_1 = variables[0];
	 DeltaT_2 = variables[1];
	 phi_1 = variables[7];	
	 phi_12 = variables[2]; 
	 y_a = variables[3];
	 y_b = variables[4];
	 k_ab_x = variables[5]*cos(variables[6]);
	 k_ab_y = variables[5]*sin(variables[6]);
	 phi_ab = variables[6];

     double mt1 = sqrt(m*m+DeltaT_1*DeltaT_1);	
     double mt2 = sqrt(m*m+DeltaT_2*DeltaT_2);
	 double k_a_x = 0.5*(DeltaT_1*cos(phi_1)+DeltaT_2*cos(phi_1+phi_12)+k_ab_x);
	 double k_a_y = 0.5*(DeltaT_1*sin(phi_1)+DeltaT_2*sin(phi_1+phi_12)+k_ab_y);
	 double k_b_x = 0.5*(DeltaT_1*cos(phi_1)+DeltaT_2*cos(phi_1+phi_12)-k_ab_x);
	 double k_b_y = 0.5*(DeltaT_1*sin(phi_1)+DeltaT_2*sin(phi_1+phi_12)-k_ab_y);	 

	 double mta = sqrt(mpi*mpi+k_a_x*k_a_x+k_a_y*k_a_y);
	 double mtb = sqrt(mpi*mpi+k_b_x*k_b_x+k_b_y*k_b_y);	 
	 
     double U = sqs-mta*cosh(y_a)-mtb*cosh(y_b);
     double V = -mta*sinh(y_a)-mtb*sinh(y_b);
	 double dUV = U*U-V*V;
	 double dmt12=mt1-mt2;
	 double pmt12=mt1+mt2;
     double pfin1z = (V*(dUV+dmt12*pmt12)+froot*U*sqrt((dUV-dmt12*dmt12)*(dUV-pmt12*pmt12)))*0.5/dUV;
     double pfin2z = V-pfin1z;
     double Efin1 = 0.5*(dUV+dmt12*pmt12+2.0*V*pfin1z)/U;
     double Efin2 = 0.5*(dUV-dmt12*pmt12+2.0*V*pfin2z)/U;

     k_1 = {mta*cosh(y_a),k_a_x,k_a_y,mta*sinh(y_a)}; 
     k_2 = {mtb*cosh(y_b),k_b_x,k_b_y,mtb*sinh(y_b)};
     p1_cor = {Efin1,-DeltaT_1*cos(phi_1),-DeltaT_1*sin(phi_1),pfin1z}; 
     p2_cor = {Efin2,-DeltaT_2*cos(phi_1+phi_12),-DeltaT_2*sin(phi_1+phi_12),pfin2z}; 	 
	 pc_cor = {sqs-p1_cor[0]-p2_cor[0],-p1_cor[1]-p2_cor[1],-p1_cor[2]-p2_cor[2],-p1_cor[3]-p2_cor[3]}; 
	 		
	 M_c = sqrt(hadron1.Lmult(pc_cor,pc_cor));
	 M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1 + DeltaT_2*DeltaT_2 + 2.0*DeltaT_1*DeltaT_2*cos(phi_12));	 

     xi_1 = (pc_cor[0]+pc_cor[3])/sqs;
	 xi_2 = (pc_cor[0]-pc_cor[3])/sqs;

	 y_c = 0.5*log(xi_1/xi_2); 
	 
	 Delta_1 = hadron1.Lminus(hadron1._p(),p1_cor);
	 Delta_2 = hadron1.Lminus(hadron2._p(),p2_cor);
	 
// transform to dd to obtain Eta_j, Phi_j
    std::vector<double> kstar = Transform_CMpp_to_CMdd(k_1);
	Eta_j = atanh(2.0*kstar[3]/M_c);

    double kT = sqrt(0.25*M_c*M_c/cosh(Eta_j)/cosh(Eta_j)-_masses[1]*_masses[1]);
	if(0.25*M_c*M_c/cosh(Eta_j)/cosh(Eta_j)-_masses[1]*_masses[1] < 0.0){
		flag = 3 ; 
	}	
	
	Theta_j = acos(kstar[3]/sqrt(kstar[3]*kstar[3]+kT*kT));	
	 
	}		
	
// Values of Delta_1 and Delta_2 to satisfy mass-shell condition
	DeltasInit();
	
	Delta3D_1 = sqrt(DeltaT_1*DeltaT_1+Delta_1[3]*Delta_1[3]);
	Delta3D_2 = sqrt(DeltaT_2*DeltaT_2+Delta_2[3]*Delta_2[3]);
	
	Delta_1[1] = DeltaT_1 * cos(phi_1);
	Delta_1[2] = DeltaT_1 * sin(phi_1);	
	Delta_2[1] = DeltaT_2 * cos(phi_12+phi_1);
	Delta_2[2] = DeltaT_2 * sin(phi_12+phi_1);
	
	std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);

    t_1 = -hadron1.Lmult(Delta_1,Delta_1);
	t_2 = -hadron1.Lmult(Delta_2,Delta_2);	
	
if(_ID != 4){ 
// corrected momenta
// final hadrons an central particle	
    p1_cor = hadron1.Lminus(hadron1._p(),Delta_1); 
    p2_cor = hadron1.Lminus(hadron2._p(),Delta_2); 
    pc_cor = {sqs-p1_cor[0]-p2_cor[0],-p1_cor[1]-p2_cor[1],-p1_cor[2]-p2_cor[2],-p1_cor[3]-p2_cor[3]};

/*	
	std::cout << "mass shell p1-Delta1 -> " << sqrt(hadron1.Lmult(p1_cor,p1_cor)) << " ? = m_p = " << m << std::endl;
	std::cout << "mass shell p2-Delta2 -> " << sqrt(hadron1.Lmult(p2_cor,p2_cor)) << " ? = m_p = " << m << std::endl;
	std::cout << "mass shell pc -> " << sqrt(hadron1.Lmult(pc_cor,pc_cor)) << " ? = M_c = " << M_c << std::endl;	
*/
	M_c = sqrt(hadron1.Lmult(pc_cor,pc_cor));	
	    	
// definition of other variables for central subsystem
    double kT = sqrt(0.25*M_c*M_c/cosh(Eta_j)/cosh(Eta_j)-_masses[1]*_masses[1]);
	if(0.25*M_c*M_c/cosh(Eta_j)/cosh(Eta_j)-_masses[1]*_masses[1] < 0.0){
		flag = 3; 
	}
	
//!!!
//    if(flag != 0){
//		printf("3 flag = %1i\n", flag);
//        printf("3 flag M_c = %1.6f eta_j = %1.6f mpi = %1.6f \n", M_c, Eta_j, _masses[1]);
//	}
//!!!		
	
	double kz = 0.5*M_c*tanh(Eta_j);
    std::vector<double> k = {0.5*M_c,kT*cos(Phi_j),kT*sin(Phi_j),kz};
	Theta_j = acos(kz/sqrt(kz*kz+kT*kT));
// transform k to CMpp

    k_1 = Transform_CMdd_to_CMpp(k);

//////////////////////////////////////////////////
/*
    std::cout << "================== momenta check in KinCM VtoP4 =================================================" << std::endl;
    std::vector<double> k2ddx = {0.5*M_c,-kT*cos(Phi_j),-kT*sin(Phi_j),-kz};
    std::vector<double> k2ppx = Transform_CMdd_to_CMpp(k2ddx);
    std::cout << "k1* (before corr.) = {" << k[0] << " , " << k[1] << " , " << k[2] << " , " << k[3] << " } " << std::endl;
    std::cout << "k2* (before corr.) = {" << k[0] << " , " << -k[1] << " , " << -k[2] << " , " << -k[3] << " } " << std::endl;  
    std::cout << "k1 (before corr.) = {" << k_1[0] << " , " << k_1[1] << " , " << k_1[2] << " , " << k_1[3] << " } " << std::endl; 
    std::cout << "k2 (before corr.) = {" << k2ppx[0] << " , " << k2ppx[1] << " , " << k2ppx[2] << " , " << k2ppx[3] << " } " << std::endl;
	std::cout << "mass shell k1* -> " << sqrt(hadron1.Lmult(k,k)) << " ? = m_pi = " << mpi << std::endl;
	std::cout << "mass shell k2* -> " << sqrt(hadron1.Lmult(k2ddx,k2ddx)) << " ? = m_pi = " << mpi << std::endl;
	std::cout << "mass shell k1 -> " << sqrt(hadron1.Lmult(k_1,k_1)) << " ? = m_pi = " << mpi << std::endl;
	std::cout << "mass shell k2 -> " << sqrt(hadron1.Lmult(k2ppx,k2ppx)) << " ? = m_pi = " << mpi << std::endl;
*/
/////////////////////////////////////////////////

//................. 
//    printf("V to P k in C.M. dd = { %.6f, %.6f, %.6f %.6f }\n", k[0], k[1], k[2], k[3]);	
//    printf("V to P k_1 in C.M. pp = { %.6f, %.6f, %.6f %.6f }\n", k_1[0], k_1[1], k_1[2], k_1[3]);	
//    std::vector<double> k_dd = Transform_CMdd_to_CMpp(k_1);
//    printf("from transformation k =? k_dd = { %.6f, %.6f, %.6f %.6f }\n", k_dd[0], k_dd[1], k_dd[2], k_dd[3]);	
//    std::vector<double> k_pp = Transform_CMpp_to_CMdd(k_dd);
//    printf("from transformation k_1 =? k_pp = { %.6f, %.6f, %.6f %.6f }\n", k_pp[0], k_pp[1], k_pp[2], k_pp[3]);	

/*		
// corrections to mass-shell k_1, k_2  
    A = pc_cor[3]/pc_cor[0]; 
	B = (M_c*M_c+_masses[1]*_masses[1]-_masses[2]*_masses[2]+2.0*(pc_cor[1]*k_1[1]+pc_cor[2]*k_1[2]))*0.5/pc_cor[0];
	KOR = sqrt(A*A*B*B+(1.0-A*A)*(B*B-_masses[1]*_masses[1]-k_1[1]*k_1[1]-k_1[2]*k_1[2]));
	if(A*A*B*B+(1.0-A*A)*(B*B-_masses[1]*_masses[1]-k_1[1]*k_1[1]-k_1[2]*k_1[2]) < 0.0){
		flag = 2;
	}
// choose root!!!!!!!!!!!!!!!!!! how????
        double root1 = (A*B+KOR)/(1.0-A*A); 
        double root2 = (A*B-KOR)/(1.0-A*A); 
        double ar1 = abs(root1-k_1[3]);
        double ar2 = abs(root2-k_1[3]); 
        if (ar1 < ar2){
         k_1[3] = root1;
        } else{
         k_1[3] = root2;
        }

//	k_1[3] = (A*B+copysign(KOR,A*B))/(1.0-A*A);
//	k_1[3] = (A*B+KOR)/(1.0-A*A);
//	printf("A = %.6f , root1 = %.6f , root2 = %.6f\n", A, (A*B+KOR)/(1.0-A*A), (A*B-KOR)/(1.0-A*A));

//!!!
//    if(flag != 0){
//		printf("4 flag = %1i\n", flag);
//	}
//!!!	
	
	k_1[0] = A*k_1[3]+B;
//.................
//   printf("VP calc A = %.6f, B = %.6f, KOR2 = %.6f\n", A, B, A*A*B*B+(1.0-A*A)*(B*B-_masses[1]*_masses[1]-k_1[1]*k_1[1]-k_1[2]*k_1[2]));		
//.................
//    printf("V to P calc equations k_1 = { %.6f, %.6f, %.6f %.6f }\n", k_1[0], k_1[1], k_1[2], k_1[3]);		
*/	
	k_2 = hadron1.Lminus(pc_cor,k_1);	
	
// define additional variables
   y_a = 0.5*log((k_1[0]+k_1[3])/(k_1[0]-k_1[3]));
   y_b = 0.5*log((k_2[0]+k_2[3])/(k_2[0]-k_2[3]));
   k_ab_x = k_1[1]-k_2[1];
   k_ab_y = k_1[2]-k_2[2];
   double k_ab_t = sqrt(k_ab_x*k_ab_x+k_ab_y*k_ab_y);
   if(k_ab_y >= 0){
	 phi_ab = acos(k_ab_x/k_ab_t);  
   }else{
	 phi_ab = 2.0*PI-acos(k_ab_x/k_ab_t); 
   }    

///////////////////////////////////////////////
//    std::cout << "k1 (after corr.) = {" << k_1[0] << " , " << k_1[1] << " , " << k_1[2] << " , " << k_1[3] << " } " << std::endl; 
//    std::cout << "k2 (after corr.) = {" << k_2[0] << " , " << k_2[1] << " , " << k_2[2] << " , " << k_2[3] << " } " << std::endl;
//    std::cout << "================== momenta check in KinCM VtoP4 =================================================" << std::endl;
//////////////////////////////////////////////
}

	ExDiff::Particle fin0(p1_cor,_masses[0],_IDs[0],hadron1._DSpin(),hadron1._Colour(),hadron1._Anticolour());
	ExDiff::Particle fin3(p2_cor,_masses[3],_IDs[3],hadron2._DSpin(),hadron2._Colour(),hadron2._Anticolour());
	particles[0] = fin0;
	particles[3] = fin3;
	
// sub-variables    	
    std::vector<double> v_t_hat = hadron1.Lminus(Delta_1,k_1);
    s_hat = M_c*M_c; 
    t_hat = -hadron1.Lmult(v_t_hat,v_t_hat);
////////////////////////////////////////////////////////////	
   		
// scalars by default, can be changed manually	
	ExDiff::Particle fin1(k_1,_masses[1],_IDs[1],1,0,0);
	ExDiff::Particle fin2(k_2,_masses[2],_IDs[2],1,0,0);	
	
	particles[1] = fin1;
	particles[2] = fin2;

//!!!
//    if(flag != 0){
//		printf("5 flag = %1i\n", flag);
//	}
//!!!		
	
    PtoV4();

//!!!
//    if(flag != 0){
//		printf("6 flag = %1i\n", flag);
//	}
//!!!	
	
	return;
};
/////////////////////////////////////////////////////
// t variables everywhere means abs(t)   
// initializations, if we know all particles momenta
void ExDiff::KinCM::PtoV2(){
	Delta = hadron1.Lminus(hadron1._p(),particles[0]._p());
	t = -hadron1.Lmult(Delta,Delta);
	double m = particles[0]._m();
	double beta = sqrt(1.0-4.0*m*m/sqs/sqs);
//	theta = acos(1-2.0*t/sqs/sqs/beta/beta);
	y = 0.5 * log((particles[0]._E()+particles[0]._pz())/(particles[0]._E()-particles[0]._pz()));	
	theta = acos(particles[0]._pz()/particles[0]._p3D());
    if(-particles[0]._py() >=0){	
	 phi = acos(-particles[0]._px()/particles[0]._pT());
    } else {
	 phi = 2.0*PI - acos(-particles[0]._px()/particles[0]._pT());	
	}
	DeltaT = particles[0]._pT();
	Delta3D = sqrt(Delta[1]*Delta[1]+Delta[2]*Delta[2]+Delta[3]*Delta[3]);

// variables by default	ID=0, {t,phi}
	variables.clear();
	variables.push_back(t);
	variables.push_back(phi);
	
	return;
};

void ExDiff::KinCM::PtoV3(){
	Delta_1 = hadron1.Lminus(hadron1._p(),particles[0]._p());
	Delta_2 = hadron2.Lminus(hadron2._p(),particles[2]._p());
	t_1 = -hadron1.Lmult(Delta_1,Delta_1);	
	t_2 = -hadron2.Lmult(Delta_2,Delta_2);
	if(-particles[0]._py() >= 0){
     phi_1 = acos(-particles[0]._px()/particles[0]._pT());
    } else {
	 phi_1 = 2.0*PI - acos(-particles[0]._px()/particles[0]._pT());	
	}	
	phi_12 = acos((Delta_1[1]*Delta_2[1]+Delta_1[2]*Delta_2[2])/particles[0]._pT()/particles[2]._pT());

//	printf("P to V phi_12 = %.6f\n",phi_12);
	
//	xi_1 = Delta_1[3]/hadron1._pz();
//	xi_2 = Delta_2[3]/hadron2._pz();

    xi_1 = (particles[1]._p()[0]+particles[1]._p()[3])/sqs;
	xi_2 = (particles[1]._p()[0]-particles[1]._p()[3])/sqs;
	
	y_c = 0.5*log(xi_1/xi_2);
	M_c = particles[1]._m();
	DeltaT_1 = particles[0]._pT(); 
	DeltaT_2 = particles[2]._pT();
	Delta3D_1 = sqrt(Delta_1[1]*Delta_1[1]+Delta_1[2]*Delta_1[2]+Delta_1[3]*Delta_1[3]);
	Delta3D_2 = sqrt(Delta_2[1]*Delta_2[1]+Delta_2[2]*Delta_2[2]+Delta_2[3]*Delta_2[3]);
// approx. formula for sqrt(s*xi_1*xi_2)		
	M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1+DeltaT_2*DeltaT_2+2.0*DeltaT_1*DeltaT_2*cos(phi_12));

// variables by default	ID=2
	variables.clear();
	variables.push_back(DeltaT_1);
	variables.push_back(DeltaT_2);
	variables.push_back(phi_12);
	variables.push_back(y_c);
	variables.push_back(phi_1);	
	
	return;
};

void ExDiff::KinCM::PtoV4(){
	Delta_1 = hadron1.Lminus(hadron1._p(),particles[0]._p());
	Delta_2 = hadron2.Lminus(hadron2._p(),particles[3]._p());
	std::vector<double> pc = hadron1.Lplus(particles[1]._p(),particles[2]._p());
	
//	particles[1].Print();
//	particles[2].Print();
	
	t_1 = -hadron1.Lmult(Delta_1,Delta_1);	
	t_2 = -hadron2.Lmult(Delta_2,Delta_2);
	if(-particles[0]._py() >= 0){
     phi_1 = acos(-particles[0]._px()/particles[0]._pT());
    } else {
	 phi_1 = 2.0*PI - acos(-particles[0]._px()/particles[0]._pT());	
	}		
	phi_12 = acos((Delta_1[1]*Delta_2[1]+Delta_1[2]*Delta_2[2])/particles[0]._pT()/particles[3]._pT());
	
//	xi_1 = Delta_1[3]/hadron1._pz();
//	xi_2 = Delta_2[3]/hadron2._pz();

    xi_1 = (pc[0]+pc[3])/sqs;
	xi_2 = (pc[0]-pc[3])/sqs;

	y_c = 0.5*log(xi_1/xi_2);
	
	std::vector<double> p_c = hadron1.Lplus(Delta_1,Delta_2);
// central mass is not a constant as in 2 to 3 process	
	M_c = sqrt(std::abs(hadron1.Lmult(p_c,p_c)));
// ........................
//    printf("M_c PtoV = %.6f\n", M_c);	
	
	DeltaT_1 = particles[0]._pT(); 
	DeltaT_2 = particles[3]._pT();
	Delta3D_1 = sqrt(Delta_1[1]*Delta_1[1]+Delta_1[2]*Delta_1[2]+Delta_1[3]*Delta_1[3]);
	Delta3D_2 = sqrt(Delta_2[1]*Delta_2[1]+Delta_2[2]*Delta_2[2]+Delta_2[3]*Delta_2[3]);
// approx. formula for sqrt(s*xi_1*xi_2)	
	M_T = sqrt(M_c*M_c + DeltaT_1*DeltaT_1+DeltaT_2*DeltaT_2+2.0*DeltaT_1*DeltaT_2*cos(phi_12));		
// hat variables
    std::vector<double> v_t_hat = hadron1.Lminus(Delta_1,particles[1]._p());
   	t_hat = -hadron1.Lmult(v_t_hat,v_t_hat);
	s_hat = M_c * M_c;
// C.M. of particles 1 and 2 subsystem

//.............
//    printf("P to V before: Eta_j = %.6f, Theta_j = %.6f, Phi_j = %.6f\n", Eta_j, Theta_j, Phi_j);	
//    printf("momentum k_1 and k_2 C.M. pp before = \n");
//	hadron1.Lprint(particles[1]._p());	
//	hadron1.Lprint(particles[2]._p());
	
    std::vector<double> k_1_CMdd = Transform_CMpp_to_CMdd(particles[1]._p());

///////////////////////////////////////////////
/*
   std::cout << "================== momenta check in KinCM PtoV4 =================================================" << std::endl;
    std::cout << "k1* (back) = {" << k_1_CMdd[0] << " , " << k_1_CMdd[1] << " , " << k_1_CMdd[2] << " , " << k_1_CMdd[3] << " } " << std::endl; 
    std::vector<double> k_2_CMdd = Transform_CMpp_to_CMdd(particles[2]._p());
    std::cout << "k2* (back) = {" << k_2_CMdd[0] << " , " << k_2_CMdd[1] << " , " << k_2_CMdd[2] << " , " << k_2_CMdd[3] << " } " << std::endl;
    std::cout << "================== momenta check in KinCM PtoV4 =================================================" << std::endl;
*/
/////////////////////////////////////////////


//	printf("momentum k_1 and k_2 C.M. pp = \n");
//	hadron1.Lprint(particles[1]._p());	
//	hadron1.Lprint(particles[2]._p());
//	printf("momentum k_1 C.M. dd = \n");
//	hadron1.Lprint(k_1_CMdd);
	
	Eta_j = 0.5 * log((k_1_CMdd[0]+k_1_CMdd[3])/(k_1_CMdd[0]-k_1_CMdd[3]));
	Theta_j = acos(k_1_CMdd[3]/sqrt(k_1_CMdd[1]*k_1_CMdd[1]+k_1_CMdd[2]*k_1_CMdd[2]+k_1_CMdd[3]*k_1_CMdd[3]));
    if(k_1_CMdd[2] >= 0.0){
		Phi_j = acos(k_1_CMdd[1]/sqrt(k_1_CMdd[1]*k_1_CMdd[1]+k_1_CMdd[2]*k_1_CMdd[2]));
	} else{
	    Phi_j = 2 * PI - acos(k_1_CMdd[1]/sqrt(k_1_CMdd[1]*k_1_CMdd[1]+k_1_CMdd[2]*k_1_CMdd[2]));
	}

// new variables
    y_a = 0.5*log((particles[1]._p()[0]+particles[1]._p()[3])/(particles[1]._p()[0]-particles[1]._p()[3]));
    y_b = 0.5*log((particles[2]._p()[0]+particles[2]._p()[3])/(particles[2]._p()[0]-particles[2]._p()[3]));
    k_ab_x = particles[1]._p()[1]-particles[2]._p()[1];
    k_ab_y = particles[1]._p()[2]-particles[2]._p()[2];
    double k_ab_t = sqrt(k_ab_x*k_ab_x+k_ab_y*k_ab_y);
    if(k_ab_y >= 0){
	  phi_ab = acos(k_ab_x/k_ab_t);  
    }else{
	  phi_ab = 2.0*PI-acos(k_ab_x/k_ab_t); 
    }    	
	
//.............
//    printf("P to V: Eta_j = %.6f, Theta_j = %.6f, Phi_j = %.6f\n", Eta_j, Theta_j, Phi_j);	
	
// variables by default	ID=0: Dro, Dphiro, phi_12, M_c, y_c; Eta_j, Phi_j; phi_1 CHANGED!!!
	variables.clear();
	variables.push_back(sqrt(DeltaT_1*DeltaT_1+DeltaT_2*DeltaT_2));
	
	if(DeltaT_1 == 0.0){
	variables.push_back(0.5*PI); 	
	}
	else{
	variables.push_back(atan(DeltaT_2/DeltaT_1));
	}
	
	variables.push_back(phi_12);
	variables.push_back(M_c);	
	variables.push_back(y_c);	
    variables.push_back(Eta_j);
    variables.push_back(Phi_j);	
	variables.push_back(phi_1);	
	
	return;
	
};
// Phys. region check and particles on-shell!
int ExDiff::KinCM::Phys(){
       
	 double eps = 1.0e-10; 
	 int n = 0;
	 double mq2, mq;
	 std::vector<double> q = particles[0]._p();
	 std::vector<double> sum = {0.0,0.0,0.0,0.0};
     for(std::size_t i = 0; i < particles.size(); i++){
		mq = particles[i]._m();
//		std::cout<< "m[" << i << "] = " << mq <<std::endl;
        q = particles[i]._p();
//        hadron1.Lprint(q);		
		mq2 = hadron1.Lmult(q,q);
//		std::cout<< "mcalc[" << i << "] = " << sqrt(mq2) <<std::endl;
		sum = hadron1.Lplus(sum,q);
		if(q[0] < -eps){
		 n = 1;	
		}		
//		particles[i].Print();
		if(particles[i].OnShell() != 0){
		 n = 2;	
		}
	 }	 
     sum = hadron1.Lminus(sum,hadron1._p());
	 sum = hadron1.Lminus(sum,hadron2._p());
	 if( std::abs(sum[0]) > eps && std::abs(sum[1]) > eps && std::abs(sum[2]) > eps && std::abs(sum[3]) > eps && n != 2){
		 n = 1;
	 }	 	 

	 if(particles.size() == 4){
    	 std::vector<double> prov = particles[0].Lplus(particles[1]._p(),particles[2]._p());
       
        if(particles[0].Lmult(prov,prov) < eps){ 
		   n = 4;
		 } else {	   
     	     double aux = sqrt(particles[0].Lmult(prov,prov)) - particles[1]._m() - particles[2]._m(); 		 
		     if(aux < -eps*eps && n != 2){
		       n = 3;
		     }
		     if(aux < -eps*eps && n == 2){
		       n = 4;
		     }	   		 
	       }
	 }	
	 
	 if(flag != 0){
		 n = 5;
	 } 
//     hadron1.Lprint(sum);  
     
//!!!
//    if(n != 0){
//		printf("nphys = %1i\n", n);
//	}
//!!!		 
	 
	 return n;
};
// Lorentz transformations from/to proton(p1)+proton(p2) C.M. frame to/from "Pomeron"(Delta_1)+ "Pomeron"(Delta_2) C.M. frame
// for 2 to 3 and 2 to 4 processes
// transformation to C.M. Delta_1+Delta_2 from C.M. proton1+proton2 (initial frame)
std::vector<double> ExDiff::KinCM::Transform_CMpp_to_CMdd(std::vector<double>& k_){	
// k_ - vector in proton_1+proton_2 C.M. frame	(initial C.M. frame)
        double eps = 1.0e-10;
		std::vector<double> res({0.0,0.0,0.0,0.0});
		std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);
		double _pT_c = sqrt(pc[1]*pc[1]+pc[2]*pc[2]);
		double _rho_c = sqrt(_pT_c*_pT_c+pc[3]*pc[3]);	
		double _eta = 1.0;
        if(pc[0]-_rho_c > eps){		
		  _eta = 0.5 * log((pc[0]+_rho_c)/(pc[0]-_rho_c));
		} else {
			std::cout<< "pc vector is irrelevant. Ec <= pc_3D" <<std::endl;
			flag = 1;
			 _eta = 100.0;
		  }
		double _cfi = pc[1]/_pT_c;
		double _sfi = pc[2]/_pT_c;
		double _ctheta = pc[3]/_rho_c;
		double _stheta = _pT_c/_rho_c;
        
		double aux1 = k_[1] * _cfi + k_[2] * _sfi;
		double aux2 = k_[3] * _ctheta + aux1 * _stheta;
		res[0] = k_[0] * cosh(_eta) - aux2 * sinh(_eta);
		res[3] = -k_[0] * sinh(_eta) + aux2 * cosh(_eta);
		res[1] = -k_[3] * _stheta + aux1 * _ctheta;
		res[2] = -k_[1] * _sfi + k_[2] * _cfi;
		
        return res;		
	};
// transformation from C.M. Delta_1+Delta_2 to C.M. proton1+proton2 (initial frame)
std::vector<double> ExDiff::KinCM::Transform_CMdd_to_CMpp(std::vector<double>& k_){
// k_ - vector in Delta_1+Delta_2 C.M. frame
        double eps = 1.0e-10;		
		std::vector<double> res({0.0,0.0,0.0,0.0});
		std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);
		double _pT_c = sqrt(pc[1]*pc[1]+pc[2]*pc[2]);
		double _rho_c = sqrt(_pT_c*_pT_c+pc[3]*pc[3]);	
		double _eta = 1.0;
        if(pc[0] - _rho_c > eps){		
		  _eta = 0.5 * log((pc[0]+_rho_c)/(pc[0]-_rho_c));
		} else {
			std::cout<< "pc vector is irrelevant. Ec <= pc_3D" <<std::endl;
			flag = 1;
			 _eta = 100.0;
		  }
		double _cfi = pc[1]/_pT_c;
		double _sfi = pc[2]/_pT_c;
		double _ctheta = pc[3]/_rho_c;
		double _stheta = _pT_c/_rho_c;
        
		double aux1 = k_[0] * sinh(_eta) + k_[3] * cosh(_eta);
		double aux2 = k_[1] * _ctheta + aux1 * _stheta;
		res[0] = k_[0] * cosh(_eta) + k_[3] * sinh(_eta);
		res[3] = aux1 * _ctheta - k_[1] * _stheta;
		res[1] = aux2 * _cfi - k_[2] * _sfi;
		res[2] = aux2 * _sfi + k_[2] * _cfi;
		
        return res;								
	};
	// other version reload
	// transformation to C.M. Delta_1+Delta_2 from C.M. proton1+proton2 (initial frame)
std::vector<double> ExDiff::KinCM::Transform_CMpp_to_CMdd_(std::vector<double>& k_, std::vector<double>& Delta_1_, std::vector<double>& Delta_2_){	
// k_ - vector in proton_1+proton_2 C.M. frame	(initial C.M. frame)
        double eps = 1.0e-10;
		std::vector<double> res({0.0,0.0,0.0,0.0});
		std::vector<double> pc = hadron1.Lplus(Delta_1_,Delta_2_);
		double _pT_c = sqrt(pc[1]*pc[1]+pc[2]*pc[2]);
		double _rho_c = sqrt(_pT_c*_pT_c+pc[3]*pc[3]);	
		double _eta = 1.0;
        if(pc[0]-_rho_c > eps){		
		  _eta = 0.5 * log((pc[0]+_rho_c)/(pc[0]-_rho_c));
		} else {
			std::cout<< "pc vector is irrelevant. Ec <= pc_3D" <<std::endl;
			flag = 1;
			 _eta = 100.0;
		  }
		double _cfi = pc[1]/_pT_c;
		double _sfi = pc[2]/_pT_c;
		double _ctheta = pc[3]/_rho_c;
		double _stheta = _pT_c/_rho_c;
        
		double aux1 = k_[1] * _cfi + k_[2] * _sfi;
		double aux2 = k_[3] * _ctheta + aux1 * _stheta;
		res[0] = k_[0] * cosh(_eta) - aux2 * sinh(_eta);
		res[3] = -k_[0] * sinh(_eta) + aux2 * cosh(_eta);
		res[1] = -k_[3] * _stheta + aux1 * _ctheta;
		res[2] = -k_[1] * _sfi + k_[2] * _cfi;
		
        return res;		
	};
// transformation from C.M. Delta_1+Delta_2 to C.M. proton1+proton2 (initial frame)
std::vector<double> ExDiff::KinCM::Transform_CMdd_to_CMpp_(std::vector<double>& k_, std::vector<double>& Delta_1_, std::vector<double>& Delta_2_){
// k_ - vector in Delta_1+Delta_2 C.M. frame
        double eps = 1.0e-10;		
		std::vector<double> res({0.0,0.0,0.0,0.0});
		std::vector<double> pc = hadron1.Lplus(Delta_1_,Delta_2_);
		double _pT_c = sqrt(pc[1]*pc[1]+pc[2]*pc[2]);
		double _rho_c = sqrt(_pT_c*_pT_c+pc[3]*pc[3]);	
		double _eta = 1.0;
        if(pc[0] - _rho_c > eps){		
		  _eta = 0.5 * log((pc[0]+_rho_c)/(pc[0]-_rho_c)); 
		} else {
			std::cout<< "pc vector is irrelevant. Ec <= pc_3D" <<std::endl;
			flag = 1;
			 _eta = 100.0;
		  }
		double _cfi = pc[1]/_pT_c;
		double _sfi = pc[2]/_pT_c;
		double _ctheta = pc[3]/_rho_c;
		double _stheta = _pT_c/_rho_c;
        
		double aux1 = k_[0] * sinh(_eta) + k_[3] * cosh(_eta);
		double aux2 = k_[1] * _ctheta + aux1 * _stheta;
		res[0] = k_[0] * cosh(_eta) + k_[3] * sinh(_eta);
		res[3] = aux1 * _ctheta - k_[1] * _stheta;
		res[1] = aux2 * _cfi - k_[2] * _sfi;
		res[2] = aux2 * _sfi + k_[2] * _cfi;
		
        return res;								
	};
	
// Special kinematical cuts for analyzers
// special kinematical cuts check
// first argument - variable to histogram, second argument - version of cuts,
// returns 0, if an event is not satisfied the cuts, 1 in other case.	
	int ExDiff::KinCM::Cuts(int& icut_){
		
		int icheck_ = 0;

		if(icut_ == 0){icheck_ = 1;}
		if(icut_ > 0){
          std::vector<double> pc = hadron1.Lplus(Delta_1,Delta_2);

//		  double etac = hadron1.Rapidity(pc);
          double etac = hadron1.Pseudorapidity(pc);
/*
          double eta1 = hadron1.Rapidity(particles[1]._p());
          double eta2 = hadron1.Rapidity(particles[2]._p());	
*/
          double eta1 = hadron1.Pseudorapidity(particles[1]._p());
          double eta2 = hadron1.Pseudorapidity(particles[2]._p());			  

		  double pt1 = particles[1]._pT();
          double pt2 = particles[2]._pT();			
		
          if(icut_ == 1){
// STAR Collaboration cuts at 200 GeV for Mc и yc distributions	
if(std::abs(etac) < 2.0 && std::abs(eta1) < 1.0 && std::abs(eta2) < 1.0 && pt1 > 0.15 && pt2 > 0.15 && t_1 > 0.005 && t_2 > 0.005 && t_1 < 0.03 && t_2 < 0.03){
              icheck_ = 1;			
		    } 		
		  }

          if(icut_ == 2){
// CDF Collaboration cuts at 1960 GeV			
            if(std::abs(y_c) < 1.0 && std::abs(eta1) < 1.3 && std::abs(eta2) < 1.3 && pt1 > 0.4 && pt2 > 0.4){	
              icheck_ = 1;			
		    } 		
		  }
		  
          if(icut_ == 3){
// LHC CMS Collaboration cuts at 8000 GeV, version 1			
            if(std::abs(eta1) < 2.0 && std::abs(eta2) < 2.0 && pt1 > 0.1 && pt2 > 0.1){	
              icheck_ = 1;			
		    } 		
		  }

          if(icut_ == 4){
// STAR Collaboration cuts at 200 GeV for phi0 distribution				
if(std::abs(etac) < 2.0 && std::abs(eta1) < 1.0 && std::abs(eta2) < 1.0 && pt1 > 0.15 && pt2 > 0.15 && t_1 > 0.005 && t_2 > 0.005 && t_1 < 0.03 && t_2 < 0.03 && M_c > 0.5 && M_c < 1.0){	
              icheck_ = 1;			
		    } 		
		  }	  

          if(icut_ == 5){
// LHC ALICE Collaboration cuts at 7000 GeV, version 1			
            if(std::abs(eta1) < 0.9 && std::abs(eta2) < 0.9 && pt1 > 0.1 && pt2 > 0.1){	
              icheck_ = 1;			
		    } 		
		  }
		  
		  
		}
		
		return icheck_;
		
    };
